=== modified file 'procurement_request/__openerp__.py'
--- procurement_request/__openerp__.py	2011-05-13 15:44:20 +0000
+++ procurement_request/__openerp__.py	2011-05-16 13:33:58 +0000
@@ -41,6 +41,10 @@
     ],
     'demo_xml': [
     ],
+    'test': [
+        'test/data.yml',
+        'test/proc_request.yml',
+    ],
     'installable': True,
     'active': False,
 #    'certificate': 'certificate',

=== modified file 'procurement_request/procurement_request.py'
--- procurement_request/procurement_request.py	2011-05-13 15:44:20 +0000
+++ procurement_request/procurement_request.py	2011-05-16 13:33:58 +0000
@@ -112,6 +112,28 @@
         'state': lambda self, cr, uid, c: c.get('procurement_request', False) and 'procurement' or 'draft',
     }
     
+    def unlink(self, cr, uid, ids, context={}):
+        '''
+        Changes the state of the order to allow the deletion
+        '''
+        line_obj = self.pool.get('sale.order.line')
+        
+        del_ids = []
+        normal_ids = []
+        
+        for request in self.browse(cr, uid, ids, context=context):
+            if request.procurement_request and request.state in ['procurement', 'proc_cancel']:
+                del_ids.append(request.id)
+            elif not request.procurement_request:
+                normal_ids.append(request.id)
+            else:
+                raise osv.except_osv(_('Invalid action !'), _('Cannot delete Procurement Request(s) which are already confirmed !'))
+                
+        if del_ids:
+            osv.osv.unlink(self, cr, uid, del_ids, context=context)
+                
+        return super(procurement_request, self).unlink(cr, uid, normal_ids, context=context)
+    
     def search(self, cr, uid, args=[], offset=0, limit=None, order=None, context={}, count=False):
         '''
         Adds automatically a domain to search only True sale orders if no procurement_request in context

=== modified file 'procurement_request/procurement_request_view.xml'
--- procurement_request/procurement_request_view.xml	2011-05-13 15:44:20 +0000
+++ procurement_request/procurement_request_view.xml	2011-05-16 13:33:58 +0000
@@ -50,7 +50,7 @@
                                     <field name="notes" />
                                     <field name="type" />
                                     <field name="latest" />
-                                    <field name="supplier_id" context="{'product_id': product_id, 'choose_supplier': True}" />
+                                    <field name="supplier_id" context="{'product_id': product_id, 'choose_supplier': True}" attrs="{'readonly': [('type', '=', 'make_to_stock')]}" />
                                     <!-- <button name="split_line" type="object" string="Split Line" icon="terp-stock_effects-object-colorize" />
                                     <button name="merge_line" type="object" string="Merge Line" icon="terp-gtk-jump-to-ltr" context="{'wizard_id': active_id}" /> -->
                                 </tree>
@@ -86,16 +86,42 @@
             <field name="arch" type="xml">
                 <tree string="Procurement Requests">
                     <field name="name" />
-                    <field name="procurement_request" />
+                    <field name="date_order" />
+                    <field name="origin" />
+                    <field name="requestor" />
+                    <field name="state" />
                 </tree>
             </field>
         </record>
         
+        <record id="procurement_request_search_view" model="ir.ui.view">
+            <field name="name">procurement.request.search.view</field>
+            <field name="model">sale.order</field>
+            <field name="type">search</field>
+            <field name="arch" type="xml">
+                <search string="Procurment Requests">
+                    <group string="Filters" expand="1">
+                        <filter name="state_proc" string="Procurement" icon="terp-document-new" domain="[('state', '=', 'procurement')]" />
+                        <filter name="state_proc_progress" string="In Progress" icon="terp-stage" domain="[('state', '=', 'proc_progress')]" />
+                        <filter name="state_done" string="Done" icon="terp-dialog-close" domain="[('state', '=', 'proc_done')]" />
+                        <separator orientation="vertical" />
+                        <field name="name" />
+                        <field name="origin" />
+                        <field name="requestor" />
+                    </group>
+                    <group string="Group By...">
+                        <filter string="State" icon="terp-gtk-select-all" domain="[]" context="{'group_by': 'state'}" />
+                    </group>
+                </search>
+            </field>
+        </record>
+        
         <record id="action_procurement_request" model="ir.actions.act_window">
             <field name="name">Procurement Requests</field>
             <field name="res_model">sale.order</field>
             <field name="view_type">form</field>
             <field name="view_mode">tree,form</field>
+            <field name="view_search_id" ref="procurement_request_search_view" />
             <field name="context">{'procurement_request': True}</field>
             <field name="domain">[('procurement_request', '=', True)]</field>
         </record>
@@ -119,4 +145,4 @@
                   parent="base.menu_sales" />
     
     </data>
-</openerp>
\ No newline at end of file
+</openerp>

=== modified file 'procurement_request/procurement_request_workflow.xml'
--- procurement_request/procurement_request_workflow.xml	2011-05-13 15:44:20 +0000
+++ procurement_request/procurement_request_workflow.xml	2011-05-16 13:33:58 +0000
@@ -24,7 +24,7 @@
             <field name="name">procurement_cancel</field>
             <field name="flow_stop">True</field>
             <field name="kind">function</field>
-            <field name="action">write({'state': 'proc_cancel')</field>
+            <field name="action">write({'state': 'proc_cancel'})</field>
         </record>
         <record id="act_proc_done" model="workflow.activity">
             <field name="wkf_id" ref="sale.wkf_sale" />

=== added directory 'procurement_request/test'
=== added file 'procurement_request/test/data.yml'
--- procurement_request/test/data.yml	1970-01-01 00:00:00 +0000
+++ procurement_request/test/data.yml	2011-05-16 13:33:58 +0000
@@ -0,0 +1,138 @@
+-
+  In order to test dates in Orders, I create initial data
+-
+    I create 3 partners
+-
+    I create supplier S1
+-
+  !record {model: res.partner, id: supplier1}:
+    name: S1
+    supplier: True
+    customer: True
+-
+    I create the address for S1
+-
+  !record {model: res.partner.address, id: address1}:
+    name: S1
+    partner_id: supplier1
+-
+    I create the supplier S2
+-
+  !record {model: res.partner, id: supplier2}:
+    name: S2
+    supplier: True
+    customer: True
+-
+    I create the address for S2
+-
+  !record {model: res.partner.address, id: address2}:
+    name: S2
+    partner_id: supplier2
+-
+    I create the supplier S3
+-
+  !record {model: res.partner, id: supplier3}:
+    name: S3
+    supplier: True
+    customer: True
+-
+    I create the address for S3
+-
+  !record {model: res.partner.address, id: address3}:
+    name: S3
+    partner_id: supplier3
+-
+    In order to test the procurement list module, I start by creating a new product category
+-
+  !record {model: product.category, id: product_cat1}:
+    name: Categ1
+-
+    I create the product P1
+-
+  !record {model: product.product, id: product1}:
+    categ_id: product_cat1
+    cost_method: standard
+    mes_type: fixed
+    name: P1
+    price_margin: 2.0
+    procure_method: make_to_stock
+    property_stock_inventory: stock.location_inventory
+    property_stock_procurement: stock.location_procurement
+    property_stock_production: stock.location_production
+    seller_delay: '1'
+    standard_price: 100.0
+    supply_method: buy
+    type: product
+    uom_id: product.product_uom_unit
+    uom_po_id: product.product_uom_unit
+    volume : 0.0
+    warranty: 0.0
+    weight: 0.0
+    weight_net: 0.0
+    seller_ids:
+      - sequence: 10
+        min_qty: 0.00
+        name: supplier1
+      - sequence: 20
+        min_qty: 0.00
+        name: supplier2
+      - sequence: 30
+        min_qty: 0.00
+        name: supplier3
+-
+    I create a second product, P2
+-
+  !record {model: product.product, id: product2}:
+    categ_id: product_cat1
+    cost_method: standard
+    mes_type: fixed
+    name: P2
+    price_margin: 2.0
+    procure_method: make_to_stock
+    property_stock_inventory: stock.location_inventory
+    property_stock_procurement: stock.location_procurement
+    property_stock_production: stock.location_production
+    seller_delay: '1'
+    standard_price: 100.0
+    supply_method: buy
+    type: product
+    uom_id: product.product_uom_unit
+    uom_po_id: product.product_uom_unit
+    volume : 0.0
+    warranty: 0.0
+    weight: 0.0
+    weight_net: 0.0
+    seller_ids:
+      - sequence: 10
+        min_qty: 0.00
+        name: supplier2
+      - sequence: 20
+        min_qty: 0.00
+        name: supplier1
+-
+    I create the product P3
+-
+  !record {model: product.product, id: product3}:
+    categ_id: product.cat0
+    cost_method: standard
+    mes_type: fixed
+    name: P3
+    price_margin: 2.0
+    procure_method: make_to_stock
+    property_stock_inventory: stock.location_inventory
+    property_stock_procurement: stock.location_procurement
+    property_stock_production: stock.location_production
+    seller_delay: '1'
+    standard_price: 100.0
+    supply_method: buy
+    type: product
+    uom_id: product.product_uom_unit    
+    uom_po_id: product.product_uom_unit
+    volume : 0.0
+    warranty: 0.0
+    weight: 0.0
+    weight_net: 0.0
+    seller_ids:
+      - sequence: 10
+        min_qty: 0.00
+        name: supplier3
\ No newline at end of file

=== added file 'procurement_request/test/proc_request.yml'
--- procurement_request/test/proc_request.yml	1970-01-01 00:00:00 +0000
+++ procurement_request/test/proc_request.yml	2011-05-16 13:33:58 +0000
@@ -0,0 +1,180 @@
+-
+  Theses tests aim to check if the behaviour of the procurement request is good
+-
+  We create a new sale order
+-
+  !record {model: sale.order, id: so1}:
+    name: SO1
+    company_id: base.main_company
+    picking_policy: direct
+    order_policy: manual
+    invoice_quantity: order
+    partner_order_id: address1
+    partner_invoice_id: address1
+    partner_shipping_id: address1
+    partner_id: supplier1
+    pricelist_id: purchase.list0
+-
+  We check if the sale order is a normal SO
+-
+  !assert {model: sale.order, id: so1}:
+    - procurement_request == False, "Normal sale order is a procurement request !"
+-
+  We create a new procurement request
+-
+  !record {model: sale.order, id: pr1, context: {'procurement_request': True}}:
+    name: PR1
+-
+  We check if the new procurement request is a good procurement request
+-
+  !assert {model: sale.order, id: pr1}:
+    - procurement_request == True, "The procurement requests is not considered than a procurement request"
+-
+  We create a new procurement request to check the workflow
+-
+  !record {model: sale.order, id: pr2, context: {'procurement_request': True}}:
+    name: PR2
+-
+  We create lines for this procurement request
+-
+  !record {model: sale.order.line, id: pr2l1, context: {'procurement_request': True}}:
+    name: P1
+    product_id: product1
+    product_uom: product.product_uom_unit
+    product_uom_qty: 150.00
+    type: make_to_order
+    order_id: pr2
+-
+  We create a second line
+-
+  !record {model: sale.order.line, id: pr2l2, context: {'procurement_request': True}}:
+    name: P2
+    product_id: product2
+    product_uom: product.product_uom_unit
+    product_uom_qty: 150.00
+    type: make_to_order
+    order_id: pr2
+-
+  We validate this procurement request
+-
+  !workflow {model: sale.order, action: procurement_confirm, ref: pr2}
+-
+  We check the state of the procurement request
+-
+  !assert {model: sale.order, id: pr2}:
+    - state == 'proc_progress', "Bad state for the procurement request"
+-
+  We close this procurement request
+-
+  !workflow {model: sale.order, action: order_confirm, ref: pr2}
+-
+  We check the state of the procurement request
+-
+  !assert {model: sale.order, id: pr2}:
+    - state == 'proc_done', "Bad state for the procurement request"
+-
+  We create a new procurement request to check the workflow
+-
+  !record {model: sale.order, id: pr3, context: {'procurement_request': True}}:
+    name: PR3
+-
+  We create lines for this procurement request
+-
+  !record {model: sale.order.line, id: pr3l1, context: {'procurement_request': True}}:
+    name: P1
+    product_id: product1
+    product_uom: product.product_uom_unit
+    product_uom_qty: 150.00
+    type: make_to_order
+    order_id: pr3
+-
+  We create a second line
+-
+  !record {model: sale.order.line, id: pr3l2, context: {'procurement_request': True}}:
+    name: P2
+    product_id: product2
+    product_uom: product.product_uom_unit
+    product_uom_qty: 150.00
+    type: make_to_order
+    order_id: pr3
+-
+  We validate this procurement request
+-
+  !workflow {model: sale.order, action: procurement_confirm, ref: pr3}
+-
+  We check the state of the procurement request
+-
+  !assert {model: sale.order, id: pr3}:
+    - state == 'proc_progress', "Bad state for the procurement request"
+-
+  We close this procurement request
+-
+  !workflow {model: sale.order, action: procurement_cancel, ref: pr3}
+-
+  We check the state of the procurement request
+-
+  !assert {model: sale.order, id: pr3}:
+    - state == 'cancel', "Bad state for the procurement request"
+-
+  !record {model: sale.order, id: pr4, context: {'procurement_request': True}}:
+    name: PR4
+-
+  We create lines for this procurement request
+-
+  !record {model: sale.order.line, id: pr4l1, context: {'procurement_request': True}}:
+    name: P1
+    product_id: product1
+    product_uom: product.product_uom_unit
+    product_uom_qty: 150.00
+    type: make_to_order
+    order_id: pr4
+-
+  We create a second line
+-
+  !record {model: sale.order.line, id: pr4l2, context: {'procurement_request': True}}:
+    name: P2
+    product_id: product2
+    product_uom: product.product_uom_unit
+    product_uom_qty: 150.00
+    type: make_to_order
+    order_id: pr4
+-
+  We validate this procurement request
+-
+  !workflow {model: sale.order, action: procurement_confirm, ref: pr4}
+-
+  We check the state of the procurement request
+-
+  !assert {model: sale.order, id: pr4}:
+    - state == 'proc_progress', "Bad state for the procurement request"
+-
+  We close this procurement request
+-
+  !workflow {model: sale.order, action: procurement_cancel, ref: pr4}
+-
+  We copy the procurement request
+-
+  !python {model: sale.order}: |
+    pr_id = self.copy(cr, uid, ref('pr4'))
+    new_pr = self.browse(cr, uid, pr_id)
+    assert len(new_pr.order_line) == 2, "Bad number of lines on copy"
+    assert new_pr.state == 'procurement', "Bad state on copy"
+-
+  We check if it's no possible to unlink a confirmed purchase_order
+-
+  !python {model: sale.order}: |
+    from osv import osv
+    try:
+      self.unlink(cr, uid, [ref('pr2')])
+      assert False, "Error on deletion of a confirmed procurement request"
+    except osv.except_osv, e:
+      assert True
+-
+  We check if it's possible to unlink a draft procurement request
+-
+  !python {model: sale.order}: |
+    from osv import osv
+    try:
+      self.unlink(cr, uid, [ref('pr1')])
+    except osv.except_osv, e:
+      assert False, "Error on deletion of a draft procurement request"
\ No newline at end of file

